#include "QUANTA/QUANTAinit.hxx"
#include "TCPClient.h"

CTCPClient::CTCPClient(char* IP, int port) 
{
	QUANTAinit();
	m_Client = new QUANTAnet_tcpClient_c;
	if (IP != NULL && port != 0) 
		m_Client->connectToServer(IP, port);
}

CTCPClient::CTCPClient(QUANTAnet_tcpClient_c* client)
{
	m_Client = client;
}

CTCPClient::~CTCPClient() 
{
	if (m_Client) {
		delete m_Client;
	}
}

void CTCPClient::SetSendAddress(char* IP, int port)
{
	m_Client->connectToServer(IP, port);
}

void CTCPClient::Send(char* sendmsg, int& dataSize) // write
{
	m_Client->write(sendmsg, &dataSize, QUANTAnet_tcpClient_c::BLOCKING);
}

int CTCPClient::Receive(char* recvline, int& dataSize, int blockingType) // read
{
	int status = m_Client->read(recvline, &dataSize, blockingType);
	return status;
}

void CTCPClient::setClient(QUANTAnet_tcpClient_c* client)
{
	m_Client = client;
}